from Plugins.Plugin import PluginDescriptor

#for ChannelContextMenu
from Screens.ChannelSelection import ChannelContextMenu
from Tools.BoundFunction import boundFunction
from Components.ChoiceList import ChoiceEntryComponent

import PiPChannelSelection
import PiPChannelSelectionSetup

reload_value = True
VERSION = "0.0.10 beta"

def sessionstart(reason, **kwargs):
	global session
	global updateTimer
	global updateTimer_conn
	
	if kwargs.has_key("session") and reason == 0:
		session = kwargs["session"]
		print "=== [PiPChannelSelection] sessionstart....", session
		from PiPChannelSelection import overwriteFunctions
		overwriteFunctions()
		
	else:
		print "=====[PiPChannelSelection] sessionstart ohne session...."
		pass

ChannelContextMenu_org__init__ = ChannelContextMenu.__init__
def ChannelContextMenu__init__(self, session, csel, *args, **kwargs):
	ChannelContextMenu_org__init__(self, session, csel, *args, **kwargs)
	self["menu"].list.insert(-1, ChoiceEntryComponent(text = (_("PiPChannelSelection Setup"), boundFunction(ChannelContextMenu_Setup,self))))
ChannelContextMenu.__init__ = ChannelContextMenu__init__

def ChannelContextMenu_Setup(self):
	if reload_value:
		reload(PiPChannelSelectionSetup)
	from PiPChannelSelectionSetup import PiPChannelSelectionSetup as Setup
	self.session.openWithCallback(self.close, Setup)

def main(session, **kwargs):

	if reload_value:
		reload(PiPChannelSelectionSetup)
	try:
		from PiPChannelSelectionSetup import PiPChannelSelectionSetup as Setup
		session.open(Setup)

	except:
		import traceback
		traceback.print_exc()


def Plugins(**kwargs):

	descriptors = []
	descriptors.append( PluginDescriptor(name =_("PiPChannelSelection"), description=_("PiPChannelSelection"), where= PluginDescriptor.WHERE_SESSIONSTART, fnc=sessionstart))
	descriptors.append( PluginDescriptor(name =_("PiPChannelSelection (Setup)"), description=_("Setup for PiPChannelSelection"), where=[ PluginDescriptor.WHERE_EXTENSIONSMENU, PluginDescriptor.WHERE_PLUGINMENU ], fnc = main, needsRestart = False, icon="PiPChannelSelection.png") )
	
	return descriptors
